/**
 * Created by zhouhuan on 2017/11/21.
 */
import React from 'react';
import { uniqBy } from 'lodash';
import { Button, Input, Upload, Form, message, Icon, Modal, Radio } from 'antd';
import { encrypt } from '../../../../utils/helper';
import config from '../../../../utils/config';
import styles from './add.less';
import { thisPush } from '../../../../services/route';

const { TextArea } = Input;
const RadioGroup = Radio.Group;

class AddDeploy extends React.Component {
  state = {
    descriptionInfo: '',
    radioValue: false,
  };
  componentDidMount() {
    this.props.dispatch({ type: 'appInfo/getTokens' });
  }
  onChangeInfo = (e) => {
    this.setState({ descriptionInfo: e.target.value });
  };
  onCancel = () => {
    const { value } = this.props.location.state;
    thisPush(this, { pathname: '../deploy', state: { value } });
  };
  onChange = (e) => {
    this.setState({
      radioValue: e.target.value,
    });
  };
  onSubmit = () => {
    const { descriptionInfo, radioValue } = this.state;
    const { value } = this.props.location.state;
    const { uploadURL } = this.props.appInfo;
    const name = value.name;
    if (uploadURL === '') {
      Modal.error({
        title: '请先上传Apk!',
      });
    } else {
      const values = { idOrName: name, uri: uploadURL, description: descriptionInfo, release: radioValue };
      this.props.dispatch({ type: 'appInfo/addDeployApp', payload: { values } });
      thisPush(this, { pathname: '../deploy', state: { value } });
    }
  };
  render() {
    const { token, uploadURL } = this.props.appInfo;
    // console.log(token);
    // console.log(uploadURL);
    const tokens = encrypt(token);
    // let URL;
    // if (uploadURL !== '') {
    //   URL = `${config.apiContextPath}/resource/${tokens}/${encodeURIComponent(uploadURL)}`;
    // }
    let action;
    if (uploadURL) {
      action = `${config.apiContextPath}/resource/${tokens}/${encodeURIComponent(uploadURL)}`;
    } else {
      action = `${config.apiContextPath}/resource/${tokens}`;
    }
    const props = {
      name: 'test',
      accept: '.apk',
      action,
      headers: {
        authorization: 'authorization-text',
      },
      fileList: this.state.fileList,
      data: (file) => {
        return file;
      },
      onChange: (info) => {
        if (info.file.status !== 'uploading') {
          // console.log(info.file, info.fileList);
        }
        if (info.file.status === 'done') {
          message.success(`${info.file.name} file uploaded successfully`);
          const response = info.file.response;
          this.props.dispatch({ type: 'appInfo/uploadAPK', payload: { response } });
        } else if (info.file.status === 'error') {
          message.error(`${info.file.name} file upload failed.`);
        }
        let fileList = info.fileList;
        fileList = fileList.slice(-3);
        fileList = fileList.filter((file) => {
          if (file.response) {
            return file.response.errorCode === 0;
          }
          return true;
        });
        fileList = fileList.map((file) => {
          if (file.response) {
            // Component will show file.url as link
            // eslint-disable-next-line
            file.url = `${config.apiContextPath}/resource/${tokens}/${encodeURIComponent(file.response.data[0])}`;
          }
          return file;
        });
        fileList = uniqBy(fileList, (file) => {
          const url = file.url;
          return url ? url.slice(url.lastIndexOf('/')) : null;
        });
        this.setState({
          fileList,
        });
      },
    };
    return (
      <div className={styles.wrapper}>
        <div className={styles.container}>
          <div className={styles.divRow}>
            <TextArea rows={5} placeholder="description" onChange={this.onChangeInfo} />
          </div>
          <div className={styles.divRow}>
            <RadioGroup onChange={this.onChange} value={this.state.radioValue}>
              <Radio value={false}>development</Radio>
              <Radio value>release</Radio>
            </RadioGroup>
          </div>
          <div className={styles.divBtn}>
            <Button type="primary" icon="check" onClick={this.onSubmit}>提交</Button>
            <Button type="primary" icon="close" onClick={this.onCancel}>取消</Button>
            <Upload {...props}>
              <Button type="primary">
                <Icon type="upload" /> 选择上传
              </Button>
            </Upload>
          </div>
        </div>
      </div>
    );
  }
}
export default Form.create()(AddDeploy);
