import React from 'react';
import { Button, Input, Form } from 'antd';
import styles from './add.less';
import { thisPush } from '../../../../services/route';

const FormItem = Form.Item;
class Edit extends React.Component {

  onCancel = () => {
    thisPush(this, { pathname: '../list' });
  };
  handleSubmit = (e) => {
    e.preventDefault();
    this.props.form.validateFields((err, values) => {
      if (!err) {
        this.props.dispatch({ type: 'appInfo/editAppInfo', payload: { values } });
      }
    });
  };
  render() {
    const { value } = this.props.location.state;
    const { getFieldDecorator } = this.props.form;
    return (
      <div className={styles.wrapper}>
        <div className={styles.container}>
          <Form onSubmit={this.handleSubmit}>
            <FormItem
              label="名称"
              labelCol={{ span: 4 }}
              wrapperCol={{ span: 8 }}
            >
              {getFieldDecorator('name', {
                rules: [{ required: true, message: 'Please input your name!' }],
                initialValue: value.name,
              })(
                <Input disabled />,
              )}
            </FormItem>
            <FormItem
              label="新名称"
              labelCol={{ span: 4 }}
              wrapperCol={{ span: 8 }}
            >
              {getFieldDecorator('newName', {
                rules: [{ required: true, message: 'Please input your newName!' }],
              })(
                <Input />,
              )}
            </FormItem>
            <FormItem
              label="包名"
              labelCol={{ span: 4 }}
              wrapperCol={{ span: 8 }}
            >
              {getFieldDecorator('packageName', {
                rules: [{ required: true, message: 'Please input your packageName!' }],
                initialValue: value.packageName,
              })(
                <Input />,
              )}
            </FormItem>
            <FormItem
              label="描述"
              labelCol={{ span: 4 }}
              wrapperCol={{ span: 8 }}
            >
              {getFieldDecorator('description', {
                initialValue: value.description,
              })(
                <Input />,
              )}
            </FormItem>
            <FormItem
              wrapperCol={{ span: 8, offset: 4 }}
            >
              <Button type="primary" htmlType="submit">
                提交
              </Button>
              <Button style={{ marginLeft: 60 }} onClick={this.onCancel}>
                返回
              </Button>
            </FormItem>
          </Form>
        </div>
      </div>
    );
  }
}
export default Form.create()(Edit);
