/**
 * Created by zhouhuan on 2017/11/24.
 */
import React from 'react';
import { Button, Input, Select, Form } from 'antd';
import styles from './add.less';
import { thisPush } from '../../../../services/route';

const FormItem = Form.Item;
const { TextArea } = Input;
const Option = Select.Option;
class EditDeploy extends React.Component {
  componentDidMount() {
    // this.props.dispatch({ type: 'appInfo/getTokens' });
  }
  onCancel = () => {
    const { value } = this.props.location.state;
    thisPush(this, { pathname: '../deploy', state: { value } });
  };
  handleSubmit = (e) => {
    e.preventDefault();
    this.props.form.validateFields((err, values) => {
      if (!err) {
        const { value } = this.props.location.state;
        this.props.dispatch({ type: 'appInfo/editSaveDeploy', payload: { values, name: value.name } });
        thisPush(this, { pathname: '../deploy', state: { value } });
      }
    });
  };
  render() {
    const { getFieldDecorator } = this.props.form;
    const { record } = this.props.location.state;
    const selects = (
      <Select>
        <Option key="release">公开版本</Option>
        <Option key="development">测试版</Option>
        <Option key="broken">重大bug版本</Option>
      </Select>
    );
    return (
      <div className={styles.wrapper}>
        <div className={styles.container}>
          <Form onSubmit={this.handleSubmit}>
            <FormItem
              label="ID"
              labelCol={{ span: 4 }}
              wrapperCol={{ span: 8 }}
            >
              {getFieldDecorator('id', {
                rules: [{ required: true, message: 'Please input your name!' }],
                initialValue: record.id,
              })(
                <Input disabled />,
              )}
            </FormItem>
            <FormItem
              label="部署描述"
              labelCol={{ span: 4 }}
              wrapperCol={{ span: 8 }}
            >
              {getFieldDecorator('description', {
                initialValue: record.description,
              })(
                <TextArea rows={5} />,
              )}
            </FormItem>
            <FormItem
              label="部署状态"
              labelCol={{ span: 4 }}
              wrapperCol={{ span: 8 }}
            >
              {getFieldDecorator('status', {
                initialValue: record.status,
              })(
                selects,
              )}
            </FormItem>
            <FormItem
              wrapperCol={{ span: 8, offset: 4 }}
            >
              <Button type="primary" htmlType="submit">
                提交
              </Button>
              <Button style={{ marginLeft: 60 }} onClick={this.onCancel}>
                返回
              </Button>
            </FormItem>
          </Form>
        </div>
      </div>
    );
  }
}
export default Form.create()(EditDeploy);
